
#include <stdio.h>
#include <assert.h>

int nmoves; // Init = 0;

void move_disc(char orig, char dest)
{
     nmoves++;
     printf("%d: moving %c -> %c\n", nmoves, orig, dest);
}

void move(int n, char orig, char dest, char aux)
{
     if (n == 1) move_disc(orig, dest);
     else {
          move(n - 1, orig, aux, dest);
          move_disc(orig, dest);
          move(n - 1, aux, dest, orig);
     }

}

int main(void)
{
     int n;
     printf("Tower of Hanoi\n");
     printf("How many discs ( > 0)? ");
     scanf("%d", &n);
     assert(n > 0);
     nmoves = 0;
     move(n, 'a', 'b', 'c');
     printf("Moves done : %d\n", nmoves);
     return 0;
}
